#!/usr/bin/perl
# Version 0.4 vom 24-06-2004

BEGIN { $| = 1; print "CM2020 Terminal loaded "; }
END {print "not ok 1\n" unless $loaded;}
use Win32::SerialPort 0.06;
use HTTP::Daemon;
use HTTP::Status;
use HTTP::Response;
use threads;
use threads::shared;
use Net::SMTP;

$loaded = 1;
print "ok 1\n";

use strict;

my $mailServer  = "Mein_Server";       # Name oder IP Adresse des SMTP Servers
my $absender    = "CM2020\@home.de";    # Emailadresse des Absenders.
my $empfaenger  = "CM2020\@home.de";  # Emailadresse des Empfngers
my $betreff     = "Die Akkus sind voll geladen";    #Betreffzeile der Mail  

my $zaehler=5;	 			#html refresh in Sekunden
my $cfgfile = "COM1_test.cfg"; 		# configuration created by test1.pl !!!
my @necessary_param = Win32::SerialPort->set_test_mode_active;
my $ob;
my $loc;
my @Status;
my $buffer=chr(0);
my $html_ausgabe:shared;
my $Akku_CHA=0; #Status, ob Akkus geladen werden
my $Akku_RDY=0;

# Constructor
$ob = Win32::SerialPort->start ($cfgfile) or die "Can't start $cfgfile\n";
$ob->error_msg(1);		# use built-in error messages
$ob->user_msg(1);

my $thr = threads->new(\&www_server);

while (1) {
	CM2020();
	sleep(2);	# Endlosschleife fragt COM-Port alle 2 Sekunden ab
}
undef $ob;			#Port schlieen

#----------- sub --------------------
sub CM2020 {
    $loc = $ob->input;
    $buffer .= $loc;
	# Hardware-Fehlerbehandlung 
	my($blk, $in, $out, $err) = $ob->status;
	#print "$blk # $in # $out # $err\n";
	if ( $err == 0x8){ 	
		undef $ob; 				#Framing Error -> Port schlieen und wieder ffnen
		$ob = Win32::SerialPort->start ($cfgfile) or die "Can't start $cfgfile\n";
	}
	#Auswertung erfolgt, wenn mind. zweimal alle Daten im Puffer sind (=4 Sekunden) 
	while (length($buffer)>441) {
		if (test_sync()) {
			CalcUI();
		}else { 
			synchron();
		}		
	}
}

sub CalcUI { 		
	# Auswertung Strom und Spannung
	$Akku_RDY = $Akku_CHA ; 	#Sicherung des alten Status
	$Akku_CHA = 0; 		#Vermutung: nichts wird geladen

	for (my $i=1; $i<=10; $i++) {
      	my ( $slot, undef, undef, $status, $cha_dis,
	        $chg_ov, $chg,  $dis_ov, $dis,
    	    $ucurr, $icurr, $hour,   $min,
        	$trigger, $exist, undef, $i_max, $counter
      	) = unpack("C5nCnCnnC7",substr($buffer,($i-1)*22,22));
      	$Status[$i][1]="";
      	$Status[$i][1]="RDY" if ((($status&0xF0)==0x40)or($status&0xF0)==0x60);
   	$Status[$i][1]="ERR" if (($status&0xF0)==0x80);
      	$Status[$i][2]="   ";
       	$Status[$i][2]="CHA" if (($status&0x0F)==7);
      	$Status[$i][2]="DIS" if (($status&0x0F)==8);
      	$Status[$i][2]="CHK" if (($status&0x0F)==9);
      	$Status[$i][2]="CYC" if (($status&0x0F)==10);
      	$Status[$i][2]="ALV" if (($status&0x0F)==11);
      	$Status[$i][3]=" ";
      	$Status[$i][3]="^" if (($cha_dis==1)or($cha_dis==3)or($cha_dis==5));
      	$Status[$i][3]="v" if (($cha_dis==2)or($cha_dis==4)or($cha_dis==6));
      	$Status[$i][4]=int(( $chg_ov * 256 + $chg ) / 100);
      	$Status[$i][5]=int(( $dis_ov * 256 + $dis ) / 100);
      	$Status[$i][6]="0" if (($status&0x0F)==0);
      	$Status[$i][6]=$ucurr/1000 if (($trigger>0)or (($status&0xF0)>0));
      	$Status[$i][7]=$icurr/1000 if (($trigger>0)or($cha_dis==1)or($cha_dis==3)or($cha_dis==5));
      	$Status[$i][8]=$hour;
      	$Status[$i][9]=$min;
      	$Status[$i][10]=$exist;
      	$Status[$i][11]=$i_max*100;
       	$Status[$i][12]="#$i:\t $Status[$i][2] $Status[$i][3]\tCC=$Status[$i][4]\tDC=$Status[$i][5]\tV=$Status[$i][6]\tI=$Status[$i][7]\t$Status[$i][8]:$Status[$i][9]\t$Status[$i][1]";
	$Status[$i][12]="" if (!$exist);
	
	$Akku_CHA=1 if (($cha_dis>0)and(($status&0xF0)==0x0)); #da wird etwas geladen...
    }
	htmldatei();	
	if (($Akku_RDY==1)and($Akku_CHA==0)) {
	  Email_RDY() #Email wg. beendeter Ladung 
	}  
	$buffer=substr($buffer,220); # ausgewerteten Block abschneiden
}

sub test_sync {		
	# testen der ersten Bytes aller 10 Slots
	for (my $k=0; $k<10; $k++ ) {
    	return 0 if (ord(substr($buffer,22*$k,1)) != $k+1);
    }
	return 1; 
}

sub synchron {
	print"synchronisiere...";
	while ((!test_sync())and(length($buffer)>220)) {
		$buffer = substr($buffer,1);  		#verhindert Endlos-Schleife
		my $SyncStart = index($buffer,chr(1));
		$buffer = substr($buffer,$SyncStart);
		print "$SyncStart Syncbytes\n";
	}
}	

sub htmldatei {
	my $html_string;
	#groe Tabelle erzeugen
	$html_string= "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">".
				"\n<html><head><meta http-equiv=\"refresh\" content=\"$zaehler\">".
				"<title>CM2020</title></head><body><pre><table border=\"1\"><caption>Conrad CM2020</caption>".
				"<tr><th>Slot</th><th>Progr.</th><th>Ladung CC</th><th>Entladung DC</th>".
				"<th>Spannung</th><th>Strom</th><th> h:min </th><th> RDY </th></tr>";
	foreach (1..10) {
		$html_string .= "<tr><td>".$_."</td>"; 
		if ($Status[$_][2]ne "   ") {
			$html_string .= "<td><P ALIGN=\"CENTER\">$Status[$_][2]</td><td><P ALIGN=\"RIGHT\">".$Status[$_][4]." mAh</td>
				<td><P ALIGN=\"RIGHT\">".$Status[$_][5]." mAh</td><td><P ALIGN=\"RIGHT\">".$Status[$_][6]." V</td><td><P ALIGN=\"RIGHT\">".$Status[$_][7]." A</td>
				<td><P ALIGN=\"CENTER\">".$Status[$_][8].":".$Status[$_][9]."</td><td><P ALIGN=\"CENTER\">$Status[$_][3]$Status[$_][1]</td>\n";
		}
		$html_string .= "</tr>";
	}
	$html_string .= "</table><br>\n";
	#kleine Tabelle	erzeugen
	$html_string .= "<table border=\"1\"><caption>mini table</caption>".
				"<tr><th colspan=\"2\">links [mAh]</th><th colspan=\"2\">rechts [mAh]</th></tr>".
				"<tr><th>CC</th><th>DC</th><th>CC</th><th>DC</th></tr>";
	foreach (1..5) {
		$html_string .= "<tr><td><P ALIGN=\"RIGHT\"><FONT COLOR=\"\#000099\">".$Status[(2*$_)-1][4]."</td><td><P ALIGN=\"RIGHT\">".$Status[(2*$_)-1][5]."</td>
				<td><P ALIGN=\"RIGHT\"><FONT COLOR=\"\#000099\">".$Status[2*$_][4]."</td><td><P ALIGN=\"RIGHT\">".$Status[2*$_][5]."</td></tr>\n";
	}
	$html_string .= "</table>";
	#Timer einblenden	
	my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat,
    	$Jahr, $Wochentag, $Jahrestag, $Sommerzeit) = localtime(time);
	$html_string .= "letzte Aktualisierung => ".$Monatstag.".".($Monat+1)."./".$Stunden.":".$Minuten.":".$Sekunden;
	$html_string .= "<br></pre></body></html>\n";
	$html_ausgabe = $html_string; #bergabe des montierten Strings
}

sub Email_RDY {
	my $smtp = Net::SMTP->new($mailServer);    # Ein neues SMTP Objekt wird erzeugt.
	$smtp->mail($absender); 
        $smtp->to($empfaenger);
        $smtp->data();                          # Dem SMTP Server wird mitgeteilt, da nun der Nachrichtentext folgt.
        $smtp->datasend("Subject: $betreff\n"); # Betreffszeile 
        $smtp->datasend("To: $empfaenger\n");   # Empfnger Emailadresse
        $smtp->datasend("MIME-Version: 1.0\nContent-type: text/html");
        $smtp->datasend("\n");                  # Leerzeile 
        $smtp->datasend("$html_ausgabe");	# bergabe des montierten Strings
        $smtp->dataend();
        $smtp->quit;
}

sub www_server {
 my $srv = HTTP::Daemon->new(LocalPort => 3037,) || die;
 print "Please contact me at: <URL:", $srv->url, ">\n";
 while (my $conn = $srv->accept) {
     my $resp = $conn->get_request ;	#while-loop gelscht fr mehrere parallele Zugriffe 
         if ($resp->method eq 'GET' ) {
         	my $response = new HTTP::Response;
                $response->code(200);
                $response->message("OK");
                $response->header("Content-Type" => "text/html");
                $response->header("Pragma" => "no-cache");
                $response->content($html_ausgabe); #bergabe des Stringes
                $conn->send_response($response);
         }
         else {
             $conn->send_error(RC_FORBIDDEN)
         }
     $conn->close;
     undef($conn);
 }
 #exit(0); thread beendet sich
} 
